#ifndef _ARM_H_
#define _ARM_H_

/* Condition Codes */
#define EQ 0
#define NE 1
#define CS 2
#define CC 3
#define MI 4
#define PL 5
#define VS 6
#define VC 7
#define HI 8
#define LS 9
#define GE 10
#define LT 11
#define GT 12
#define LE 13

/* Types of Instructions*/
#define DATA_PROC 0
#define LD_STR 1
#define BRANCH 2
#define SWI 3

/* Opcodes */
#define AND 0
#define EOR 1
#define SUB 2
#define RSB 3
#define ADD 4
#define ADC 5
#define SBC 6
#define RSC 7
#define TST 8
#define TEQ 9
#define CMP 10
#define CMN 11
#define ORR 12
#define MOV 13
#define BIC 14
#define MVN 15

/* Shift Type */
#define LSL 0
#define LSR 1
#define ASR 2
#define ROR 3

/* Mem ops*/
#define LDRB 5
#define STRB 4
#define LDR 1
#define STR 0

/* Flag Macros */
#define set_N(x) op->CPSR = (op->CPSR & 0x7FFFFFFF) | ((x) << 31)
#define set_Z(x) op->CPSR = (op->CPSR & 0xBFFFFFFF) | ((x) << 30)
#define set_C(x) op->CPSR = (op->CPSR & 0xDFFFFFFF) | ((x) << 29)
#define set_V(x) op->CPSR = (op->CPSR & 0xEFFFFFFF) | ((x) << 28)
#define get_N() ((op->CPSR >> 31) & 0x1)
#define get_Z() ((op->CPSR >> 30) & 0x1)
#define get_C() ((op->CPSR >> 29) & 0x1)
#define get_V() ((op->CPSR >> 28) & 0x1)

#endif
